;----------------------------
; Recompiled and IDE64 fixed
; loader of the North&South
; in 2003, Visac
; Last revision: 2.5.2003
;----------------------------

sub_0_803       = $0803         ;This address is used also outside this loader

		* =  $0801
                .byte $0b,$08,$e8,$03,$9e,$32,$30,$36,$31,$00,$00,$00

                ;----------------------
                ;$080d 
                ;install  $0803   jmp load_file

                lda jmp_load_file
                sta $0803
                lda jmp_load_file+1
                sta $0804
                lda jmp_load_file+2
                sta $0805
                ;----------
                lda #<head
                ldy #>head
                jsr $ab1e               ;Print string
                ;----------
		LDA	#7
		JSR	sub_0_803
		JSR	$8000           ;"INFOGRAMES", Intro...
		LDA	#0
		STA	$037F

loc_0_813       = *
		LDX	#$FF
		TXS	
		LDA	#0
		JSR	sub_0_803
		LDA	#1
		JSR	sub_0_803
		JSR	$1000           ;"Game setup..."
		JSR	sub_0_99F       ;Clear screen
		LDA	$0389
		CLC	
		ADC	#9
		JSR	sub_0_803
		LDA	#2
		JSR	sub_0_803
		LDA	#3
		JSR	sub_0_803
		LDA	#4
		JSR	sub_0_803
		JSR	sub_0_9E2       ;Set color RAM, INFO, Wait for space...
		JSR	$0c00           ;Main Game !!!
		JSR	sub_0_99F       ;Clear screen
		LDA	$39B
		BNE	loc_0_813
		LDA	#13
		JSR	sub_0_803
		JSR	$8000           ;"End of war..."
		JSR	sub_0_99F       ;Clear screen
		JMP	loc_0_813
;--------------------------------------
head            = *
                .text $0d,$05,"NORTH & SOUTH",$0d
                .text "IDE64 FIXED BY VISAC",$0d
                .text "2003/05/02",0
jmp_load_file	.byte $4c
        	.word load_file
;--------------------------------------
; L O A D
;--------------------------------------
load_file       = *
		STA	byte_0_8E7
loc_0_874
		JSR	sub_0_8B5       ;Init CIA

loc_0_889       = *
		LDA	byte_0_8E7

loc_0_88C       STA	loc_0_8B0+1
		ASL	A
		TAX	
		LDA	byte_8E8+1,X
		TAY	
		LDA	byte_8E8,X
		TAX	
		LDA	#2
		JSR	$FFBD           ;SETNAM

		LDA	#2              ;chanel num.
                ldx     $ba             ;device num.
		LDY	#0              ;sec. addr.
		JSR	$FFBA           ;SETLFS

		LDA	#0
		STA	$9D
		JSR	sub_0_A1A       ;jsr $09b4
		BCS	loc_0_8B0       ;If Error, read again...
                                        ;Well, error checking is not implemented
		RTS	
;--------------------------------------
loc_0_8B0       = *
		LDA	#0
		JMP	loc_0_88C

;--------------------------------------
sub_0_8B5       = *
		SEI	
		LDA	#$37
		STA	1
		LDA	#$7F
		STA	$DC0D
		STA	$DD0D
		LDA	#0
		STA	$DC0E
		STA	$DD0E
		BIT	$DD0D
		BIT	$DC0D
		LDA	#0
		STA	$D020
		STA	$D021
		STA	$D015
		LDA	#0
		STA	$D01A
		LDA	$D019
		STA	$D019
		RTS	
;--------------------------------------
byte_0_8E7 	.BYTE 0
byte_8E8	= *
                .word asc_oc    ;0
                .word asc_om    ;1
                .word asc_m1    ;2
                .word asc_m2    ;3
                .word asc_m3    ;4
                .word asc_s1    ;5
                .word asc_s2    ;6
                .word asc_tp    ;7
                .word asc_bs    ;8
                .word asc_t1    ;9
                .word asc_t2    ;10
                .word asc_t3    ;11
                .word asc_t4    ;12
                .word asc_cs    ;13
                .word asc_id    ;14

asc_oc          = *
		.BYTE  $4F ; O
		.BYTE  $43 ; C
asc_om          = *
		.BYTE  $4F ; O
		.BYTE  $4D ; M
asc_m1          = *
		.BYTE  $4D ; M
		.BYTE  $31 ; 1
asc_m2          = *
		.BYTE  $4D ; M
		.BYTE  $32 ; 2
asc_m3          = *
		.BYTE  $4D ; M
		.BYTE  $33 ; 3
asc_s1          = *
		.BYTE  $53 ; S
		.BYTE  $31 ; 1
asc_s2          = *
		.BYTE  $53 ; S
		.BYTE  $32 ; 2
asc_tp          = *
		.BYTE  $54 ; T
		.BYTE  $50 ; P
asc_bs          = *
		.BYTE  $42 ; B
		.BYTE  $53 ; S
asc_t1          = *
		.BYTE  $54 ; T
		.BYTE  $31 ; 1
asc_t2          = *
		.BYTE  $54 ; T
		.BYTE  $32 ; 2
asc_t3          = *
		.BYTE  $54 ; T
		.BYTE  $33 ; 3
asc_t4          = *
		.BYTE  $54 ; T
		.BYTE  $34 ; 4
asc_cs          = *
		.BYTE  $43 ; C
		.BYTE  $53 ; S
asc_id          = *
		.BYTE  $49 ; I
		.BYTE  $44 ; D
;--------------------------------------
sub_0_962       = *
		LDA	#0
		STA	$DC03
		LDA	#$FF
		STA	$DC02

;Wait for space...

loc_0_96C       LDA	$DC00
		AND	$DC01
		AND	#$10
		BNE	loc_0_96C
		RTS	
;--------------------------------------
sub_0_99F       = *
		LDX	#0
loc_0_9A1       LDA	#0
		STA	$D800,X
		STA	$D900,X
		STA	$DA00,X
		STA	$DB00,X
		LDA	#$20
		STA	$400,X
		STA	$500,X
		STA	$600,X
		STA	$700,X
		DEX	
		BNE	loc_0_9A1
loc_0_9C0       = *
		LDA	$DD02
		ORA	#3
		STA	$DD02
		LDA	$DD00
		AND	#$FC
		ORA	#3
		STA	$DD00
		LDA	#$14
		STA	$D018
		LDA	#$98
		STA	$D011
		LDA	#8
		STA	$D016
		RTS	
;--------------------------------------
sub_0_9E2       = *
		LDX	#0
loc_0_9E4       = *
		LDA	#2
		STA	$D800,X
		STA	$D900,X
		STA	$DA00,X
		LDA	#0
		STA	$DB00,X
		DEX	
		BNE	loc_0_9E4
		LDA	#$98
		STA	$D011
		LDA	#$16
		STA	$D018
		JSR	sub_0_962       ;Wait for space...
		RTS	
;--------------------------------------
sub_0_A05       = *
		LDA	#0
		TAX	
loc_0_A08       STA	$D800,X
		STA	$D900,X
		STA	$DA00,X
		STA	$DB00,X
		DEX	
		BNE	loc_0_A08
		JMP	loc_0_9C0
;--------------------------------------
; Load file into RAM
;--------------------------------------
sub_0_A1A       = *
                jsr $ffc0               ;OPEN

                ldx #2
                jsr $ffc6               ;chkin

; Read block header

loc_0_A32       LDX	#4
loc_0_A34       JSR	$ffcf           ;chrin
		STA	$FB,X
		DEX	
		BPL	loc_0_A34
		LDY	$90
		BNE	loc_0_A4A
		SEI	
		STY	1
		JSR	sub_0_A50       ;Read block
		DEC	1
		BNE	loc_0_A32
loc_0_A4A       = *
                lda #2
                jsr $ffc3               ;close
                jsr $ffe7               ;clall
                clc
                rts
;--------------------------------------
; Read block

sub_0_A50       = *
		TYA	
		STA	$F6
		STY	$F8
loc_0_A55
		JSR	sub_0_AC1
		ROL	A
		BNE	loc_0_A5D
		BCC	loc_0_A69
loc_0_A5D
		ROL	$F8
		JSR	sub_0_AC1
		BCS	loc_0_A55
		STA	$F7
		JSR	sub_0_ADD
loc_0_A69
		TYA	
		STY	$F9
		STY	$FA
loc_0_A6E
		JSR	sub_0_AC1
		ROL	A
		BEQ	loc_0_A7D
		BMI	loc_0_A7B
		JSR	sub_0_AC1
		BCS	loc_0_A6E
loc_0_A7B
		INC	$F6
loc_0_A7D
		ADC	#2
		STA	$F7
		LDX	#2
loc_0_A83
		JSR	sub_0_AC1
		ROL	$F6
		DEX	
		BNE	loc_0_A83
loc_0_A8B       = *
		LDX	$F6
		LDA	byte_B22,X
		TAX	
		BEQ	loc_0_A9D
loc_0_A93
		JSR	sub_0_AC1
		ROL	$F9
		ROL	$FA
		DEX	
		BNE	loc_0_A93
loc_0_A9D
		LDA	$F6
		AND	#3
		BEQ	loc_0_AAD
		INC	$F9
		BNE	loc_0_AA9
		INC	$FA
loc_0_AA9
		DEC	$F6
		BPL	loc_0_A8B
loc_0_AAD
		CLC	
		LDA	$FC
		ADC	$F9
		STA	$F9
		LDA	$FD
		ADC	$FA
		STA	$FA
		INC	$F6
		JSR	sub_0_AF0
		BEQ	sub_0_A50
;--------------------------------------
sub_0_AC1
		ASL	$FB
		BNE	locret_0_ADC
		CPY	$FE
		BNE	loc_0_ACF
		CPY	$FF
		BEQ	loc_0_AD9+1
		DEC	$FF
loc_0_ACF
		DEC	$FE
		PHA	
		JSR	sub_0_B19
		SEC	
		ROL	A
		STA	$FB
loc_0_AD9
		BIT	$68
		PLA	
locret_0_ADC
		RTS	
;--------------------------------------
sub_0_ADD
		SEC	
		LDA	$FE
		SBC	$F7
		STA	$F9
		STA	$FE
		LDA	$FF
		SBC	#0
		STA	$FA
		SBC	$F8
		STA	$FF
sub_0_AF0
		LDY	$F7
		BEQ	loc_0_B07
		LDA	$FC
		SEC	
		SBC	$F7
		STA	$FC
		BCS	loc_0_AFF
loc_0_AFD
		DEC	$FD
loc_0_AFF
		JSR	sub_0_B12
		STA	($FC),Y
		DEY	
		BNE	loc_0_AFF
loc_0_B07
		CPY	$F8
		BEQ	locret_0_B11
		DEC	$FA
		DEC	$F8
		BPL	loc_0_AFD
locret_0_B11
		RTS	
;--------------------------------------
sub_0_B12
		LDA	$F6
		BEQ	sub_0_B19
		LDA	($F9),Y
		RTS	
;--------------------------------------
; Get byte
sub_0_B19
		DEC	1
		JSR	$ffcf           ;chrin
		SEI	
		INC	1
		RTS	
;--------------------------------------
byte_B22        = *
		.BYTE	 4 ;  
		.BYTE	 2 ;  
		.BYTE	 2 ;  
		.BYTE	 2 ;  
		.BYTE	 5 ;  
		.BYTE	 2 ;  
		.BYTE	 2 ;  
		.BYTE	 3 ;  
;--------------------------------------
